package generatorgrafu;

import java.util.ArrayList;
import java.util.Random;
import model.Graf;

public class GeneratorDvoukomponentovehoGrafu {

    public Graf generuj(int pocetUzlu, int pocetHran, int delkaHranyMin, int delkaHranyMax) {
        Graf graf = new Graf(pocetUzlu, pocetHran, delkaHranyMin, delkaHranyMax);

        for (int i = 0; i < pocetUzlu; i = i + 1) { //for cyklus k zajištění nulové délky všech hran
            for (int j = i; j < pocetUzlu; j = j + 1) {
                graf.setPrvek(i, j, 0);
                graf.setPrvek(j, i, 0);
            }
        }

        Random random = new Random();

        ArrayList<Integer> list1 = new ArrayList<>();
        ArrayList<Integer> list2 = new ArrayList<>();

        int prvniVListu1 = random.nextInt(pocetUzlu);
        int prvniVListu2 = random.nextInt(pocetUzlu);
        while (prvniVListu1 == prvniVListu2) {
            prvniVListu2 = random.nextInt(pocetUzlu);
        }
        list1.add(prvniVListu1);
        list2.add(prvniVListu2);

        for (int i = 0; i < pocetUzlu; i = i + 1) {
            boolean rozhodovac = random.nextBoolean();
            if (i != prvniVListu1 && i != prvniVListu2) {
                if (rozhodovac) {
                    list1.add(i);
                } else {
                    list2.add(i);
                }
            }
        }

        boolean jeNulovyRadek = true;

        while (jeNulovyRadek) {
            for (int index = 0; index < list1.size() - 1; index = index + 1) {
                int i = list1.get(index);
                int j = random.nextInt(list1.size());
                while (i == j || graf.getPrvek(i, j) != 0) {
                    j = list1.get(random.nextInt(list1.size()));
                }
                graf.setPrvek(i, j, random.nextInt(delkaHranyMax - delkaHranyMin + 1) + delkaHranyMin);
                graf.setPrvek(j, i, graf.getPrvek(i, j));
            }

            for (int index = 0; index < list2.size() - 1; index = index + 1) {
                int i = list2.get(index);
                int j = random.nextInt(list2.size());
                while (i == j || graf.getPrvek(i, j) != 0) {
                    j = list2.get(random.nextInt(list2.size()));
                }
                graf.setPrvek(i, j, random.nextInt(delkaHranyMax - delkaHranyMin + 1) + delkaHranyMin);
                graf.setPrvek(j, i, graf.getPrvek(i, j));
            }

            jeNulovyRadek = false;
            for (int k = 0; k < pocetUzlu; k = k + 1) {
                for (int l = 0; l < pocetUzlu; l = l + 1) {
                    if (graf.getPrvek(k, l) != 0) {
                        jeNulovyRadek = false;
                        break;
                    }
                    if (l == pocetUzlu - 1 && graf.getPrvek(k, l) != 0) {
                        jeNulovyRadek = true;
                    }
                }
                if (jeNulovyRadek) {
                    for (int i = 0; i < pocetUzlu; i = i + 1) { //for cyklus k zajištění nulové délky všech hran
                        for (int j = i; j < pocetUzlu; j = j + 1) {
                            graf.setPrvek(i, j, 0);
                            graf.setPrvek(j, i, 0);
                        }
                    }
                    break;
                }
            }
        }

//        int pocetHranListu1 = list1.size() - 1;
//        int pocetHranListu2 = list2.size() - 1;
//
//        int zbyvaHran = pocetHran - (pocetUzlu - 2);
//
//        for (int index = 0; index < zbyvaHran; index = index + 1) {
//            boolean kteryList = random.nextBoolean(); //true --> list1
//                                                      //false --> list2
//            if (kteryList && pocetHranListu1 < (list1.size() * (list1.size() - 1)) / 2) {
//                int i = list1.get(random.nextInt(list1.size()));
//                int j = list1.get(random.nextInt(list1.size()));
//                while (i == j || graf.getPrvek(i, j) != 0) {
//                    j = list1.get(random.nextInt(list1.size()));
//                }
//                graf.setPrvek(i, j, random.nextInt(delkaHranyMax - delkaHranyMin + 1) + delkaHranyMin);
//                graf.setPrvek(j, i, graf.getPrvek(i, j));
//                pocetHranListu1 = pocetHranListu1 + 1;
//            } else {
//                int i = list2.get(random.nextInt(list2.size()));
//                int j = list2.get(random.nextInt(list2.size()));
//                while (i == j || graf.getPrvek(i, j) != 0) {
//                    j = list2.get(random.nextInt(list2.size()));
//                }
//                graf.setPrvek(i, j, random.nextInt(delkaHranyMax - delkaHranyMin + 1) + delkaHranyMin);
//                graf.setPrvek(j, i, graf.getPrvek(i, j));
//                pocetHranListu2 = pocetHranListu2 + 1;
//            }
//        }

        return graf;
    }

}
