package gui;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.util.Hashtable;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.WindowConstants;

public class DialogNastaveni extends JDialog {

    private JPanel panelVelikostPisma;
    private JPanel panelVelikostTabulky;

    private JLabel lblVelikostPisma;
    private JLabel lblVelikostTabulky;

    private JSlider sliderVelikostPisma;
    private JSlider sliderVelikostTabulky;

    private ValidovaneTextovePole vtpVelikostPisma;
    private ValidovaneTextovePole vtpVelikostTabulky;

    private Hashtable popisSlideruVelikostPisma = new Hashtable();
    private Hashtable popisSlideruVelikostTabulky = new Hashtable();

    public DialogNastaveni(JFrame rodicovskyFrame) {
        super(rodicovskyFrame);
        setLayout(new BoxLayout(getContentPane(), BoxLayout.Y_AXIS));
        setTitle("Velikost písma a tabulky");
        setSize(new Dimension(290, 204));
        setLocationRelativeTo(rodicovskyFrame);
        setDefaultCloseOperation(WindowConstants.HIDE_ON_CLOSE);

        panelVelikostPisma = new JPanel(new BorderLayout(10, 10));
        panelVelikostPisma.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));

        lblVelikostPisma = new JLabel("Velikost písma:");
        panelVelikostPisma.add(lblVelikostPisma, BorderLayout.NORTH);

        sliderVelikostPisma = new JSlider(JSlider.HORIZONTAL, 12, 50, 12);
        sliderVelikostPisma.setPaintLabels(true);
        popisSlideruVelikostPisma.put(sliderVelikostPisma.getMinimum(), new JLabel(String.valueOf(sliderVelikostPisma.getMinimum())));
        popisSlideruVelikostPisma.put(sliderVelikostPisma.getMaximum(), new JLabel(String.valueOf(sliderVelikostPisma.getMaximum())));
        sliderVelikostPisma.setLabelTable(popisSlideruVelikostPisma);
        panelVelikostPisma.add(sliderVelikostPisma, BorderLayout.WEST);

        vtpVelikostPisma = new ValidovaneTextovePole();
        vtpVelikostPisma.setText("12");
        panelVelikostPisma.add(vtpVelikostPisma, BorderLayout.CENTER);

        panelVelikostPisma.setMaximumSize(new Dimension(Integer.MAX_VALUE, panelVelikostPisma.getMinimumSize().height));

        add(panelVelikostPisma);

        panelVelikostTabulky = new JPanel(new BorderLayout(10, 10));
        panelVelikostTabulky.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));

        lblVelikostTabulky = new JLabel("Velikost tabulky:");
        panelVelikostTabulky.add(lblVelikostTabulky, BorderLayout.NORTH);

        sliderVelikostTabulky = new JSlider(JSlider.HORIZONTAL, 25, 75, 25);
        sliderVelikostTabulky.setPaintLabels(true);
        popisSlideruVelikostTabulky.put(sliderVelikostTabulky.getMinimum(), new JLabel(String.valueOf(sliderVelikostTabulky.getMinimum())));
        popisSlideruVelikostTabulky.put(sliderVelikostTabulky.getMaximum(), new JLabel(String.valueOf(sliderVelikostTabulky.getMaximum())));
        sliderVelikostTabulky.setLabelTable(popisSlideruVelikostTabulky);
        panelVelikostTabulky.add(sliderVelikostTabulky, BorderLayout.WEST);

        vtpVelikostTabulky = new ValidovaneTextovePole();
        vtpVelikostTabulky.setText("25");
        panelVelikostTabulky.add(vtpVelikostTabulky, BorderLayout.CENTER);

        panelVelikostTabulky.setMaximumSize(new Dimension(Integer.MAX_VALUE, panelVelikostTabulky.getMinimumSize().height));

        add(panelVelikostTabulky);

        setVisible(false);
    }

    public ValidovaneTextovePole getVtpVelikostPisma() {
        return vtpVelikostPisma;
    }

    public ValidovaneTextovePole getVtpVelikostTabulky() {
        return vtpVelikostTabulky;
    }

    public JSlider getSliderVelikostPisma() {
        return sliderVelikostPisma;
    }

    public JSlider getSliderVelikostTabulky() {
        return sliderVelikostTabulky;
    }

    public int getHodnotaVtpVelikostPisma() {
        return Integer.parseInt(vtpVelikostPisma.getText());
    }

    public int getHodnotaVtpVelikostTabulky() {
        return Integer.parseInt(vtpVelikostTabulky.getText());
    }

}
