package gui;

import java.awt.Dimension;
import javax.swing.JOptionPane;
import javax.swing.JDialog;
import java.beans.*;
import java.awt.event.*;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JLabel;

class DialogVolbyPoctuRuznychGrafu extends JDialog
        implements ActionListener,
        PropertyChangeListener {

    private String zadanaHodnota = null;
    private ValidovaneTextovePole vtpOdpoved;
    private JLabel lblPopis;
    private JOptionPane optionPane;

    private String btnString1 = "Potvrdit";
    private String btnString2 = "Zrušit";

    public DialogVolbyPoctuRuznychGrafu(JFrame rodicovskyFrame) {
        super(rodicovskyFrame, true);
        setTitle("Počet typů grafů");
        setPreferredSize(new Dimension(260, 150));
        pack();

        vtpOdpoved = new ValidovaneTextovePole();
        lblPopis = new JLabel("Zadejte počet typů grafů:");
        JComponent[] objektZpravy = {lblPopis, vtpOdpoved};
        Object[] moznostiVolby = {btnString1, btnString2};

        optionPane = new JOptionPane(objektZpravy, JOptionPane.PLAIN_MESSAGE, JOptionPane.YES_NO_OPTION, null, moznostiVolby, moznostiVolby[0]);

        setContentPane(optionPane);

        setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
        addWindowListener(new WindowAdapter() {
            @Override
            public void windowClosing(WindowEvent we) {
                optionPane.setValue(new Integer(JOptionPane.CLOSED_OPTION));
            }
        });

        addComponentListener(new ComponentAdapter() {
            @Override
            public void componentShown(ComponentEvent ce) {
                vtpOdpoved.requestFocusInWindow();
            }
        });

        vtpOdpoved.addActionListener(this);

        optionPane.addPropertyChangeListener(this);
    }

    @Override
    public void actionPerformed(ActionEvent e) {
        optionPane.setValue(btnString1);
    }

    @Override
    public void propertyChange(PropertyChangeEvent e) {
        String prop = e.getPropertyName();

        if (isVisible()
                && (e.getSource() == optionPane)
                && (JOptionPane.VALUE_PROPERTY.equals(prop)
                || JOptionPane.INPUT_VALUE_PROPERTY.equals(prop))) {
            Object value = optionPane.getValue();

            if (value == JOptionPane.UNINITIALIZED_VALUE) {
                return;
            }

            optionPane.setValue(JOptionPane.UNINITIALIZED_VALUE);

            if (btnString1.equals(value)) {
                zadanaHodnota = vtpOdpoved.getText();
                try {
                    if (0 < Integer.valueOf(vtpOdpoved.getText()) && Integer.valueOf(vtpOdpoved.getText()) < 10) {
                        skryjDialog();
                    } else {
                        vtpOdpoved.selectAll();
                        JOptionPane.showMessageDialog(DialogVolbyPoctuRuznychGrafu.this, "Zadaná hodnota musí být minimálně 1, maximálně 9.", "Chyba", JOptionPane.ERROR_MESSAGE);
                        zadanaHodnota = null;
                        vtpOdpoved.requestFocusInWindow();
                    }
                } catch (NumberFormatException nfe) {
                    JOptionPane.showMessageDialog(null, "Zadejte prosím platnou číselnou hodnotu v rozmezí 1 až 9.", "Chyba", JOptionPane.ERROR_MESSAGE);
                }
            } else {
                zadanaHodnota = null;
                skryjDialog();
            }
        }
    }

    public void skryjDialog() {
        vtpOdpoved.setText(null);
        setVisible(false);
    }

    public String getZadanaHodnota() {
        return zadanaHodnota;
    }
}
