package gui;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;

public class KostraZadaniGrafu extends JPanel {

    private JLabel lblPocetUzlu;
    private ValidovaneTextovePole vtpPocetUzlu;
    private JLabel lblPocetHran;
    private ValidovaneTextovePole vtpPocetHran;
    private JLabel lblDelkaHranyMin;
    private ValidovaneTextovePole vtpDelkaHranyMin;
    private JLabel lblDelkaHranyMax;
    private ValidovaneTextovePole vtpDelkaHranyMax;
    private JLabel lblTypGrafu;
    private JComboBox cmbTypGrafu;
    private JCheckBox cbOhodnoceniGrafu;

    public KostraZadaniGrafu() {
        super();
        setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));

        //nastevení počtu uzlů generovaného grafu
        JPanel panelPocetUzlu = new JPanel();
        panelPocetUzlu.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
        panelPocetUzlu.setLayout(new BorderLayout());

        lblPocetUzlu = new JLabel("Počet uzlů grafu:");
        lblPocetUzlu.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 10));
        panelPocetUzlu.add(lblPocetUzlu, BorderLayout.WEST);

        vtpPocetUzlu = new ValidovaneTextovePole();
        panelPocetUzlu.add(vtpPocetUzlu, BorderLayout.CENTER);

        panelPocetUzlu.setMaximumSize(new Dimension(Integer.MAX_VALUE, panelPocetUzlu.getMinimumSize().height));
        add(panelPocetUzlu);

        //nastevení počtu hran generovaného grafu
        JPanel panelPocetHran = new JPanel();
        panelPocetHran.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
        panelPocetHran.setLayout(new BorderLayout());

        lblPocetHran = new JLabel("Počet hran grafu:");
        lblPocetHran.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 10));
        panelPocetHran.add(lblPocetHran, BorderLayout.WEST);

        vtpPocetHran = new ValidovaneTextovePole();
        panelPocetHran.add(vtpPocetHran, BorderLayout.CENTER);

        panelPocetHran.setMaximumSize(new Dimension(Integer.MAX_VALUE, panelPocetHran.getMinimumSize().height));
        add(panelPocetHran);

        //nastevení minimální délky hrany generovaného grafu
        JPanel panelDelkaHranyMin = new JPanel();
        panelDelkaHranyMin.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
        panelDelkaHranyMin.setLayout(new BorderLayout());

        lblDelkaHranyMin = new JLabel("Minimální délka hrany:");
        lblDelkaHranyMin.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 10));
        panelDelkaHranyMin.add(lblDelkaHranyMin, BorderLayout.WEST);

        vtpDelkaHranyMin = new ValidovaneTextovePole();
        panelDelkaHranyMin.add(vtpDelkaHranyMin, BorderLayout.CENTER);

        panelDelkaHranyMin.setMaximumSize(new Dimension(Integer.MAX_VALUE, panelDelkaHranyMin.getMinimumSize().height));
        add(panelDelkaHranyMin);

        //nastevení maximální délky hrany generovaného grafu
        JPanel panelDelkaHranyMax = new JPanel();
        panelDelkaHranyMax.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
        panelDelkaHranyMax.setLayout(new BorderLayout());

        lblDelkaHranyMax = new JLabel("Maximální délka hrany:");
        lblDelkaHranyMax.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 10));
        panelDelkaHranyMax.add(lblDelkaHranyMax, BorderLayout.WEST);

        vtpDelkaHranyMax = new ValidovaneTextovePole();
        panelDelkaHranyMax.add(vtpDelkaHranyMax, BorderLayout.CENTER);

        panelDelkaHranyMax.setMaximumSize(new Dimension(Integer.MAX_VALUE, panelDelkaHranyMax.getMinimumSize().height));
        add(panelDelkaHranyMax);

        //nastevení typu generovaného grafu
        JPanel panelTypGrafu = new JPanel();
        panelTypGrafu.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
        panelTypGrafu.setLayout(new BorderLayout());

        lblTypGrafu = new JLabel("Typ grafu:");
        lblTypGrafu.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 10));
        panelTypGrafu.add(lblTypGrafu, BorderLayout.WEST);

        String[] seznamGrafu = {"Souvislý graf", "Strom", "Bipartitní graf", "Dvoukomponentový graf"};
        cmbTypGrafu = new JComboBox(seznamGrafu);
        panelTypGrafu.add(cmbTypGrafu, BorderLayout.CENTER);

        panelTypGrafu.setMaximumSize(new Dimension(Integer.MAX_VALUE, panelTypGrafu.getMinimumSize().height));
        add(panelTypGrafu);

        //nastavení ohodnocený/neohodnocený graf
        JPanel panelOhodnoceniGrafu = new JPanel();
        panelOhodnoceniGrafu.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
        panelOhodnoceniGrafu.setLayout(new BorderLayout());

        cbOhodnoceniGrafu = new JCheckBox("Ohodnocený graf");
        cbOhodnoceniGrafu.setSelected(true);
        cbOhodnoceniGrafu.addItemListener(new ItemListener() {
            @Override
            public void itemStateChanged(ItemEvent e) {
                if (getCbOhodnoceniGrafu().isSelected()) {
                    getLblDelkaHranyMin().setEnabled(true);
                    getVtpDelkaHranyMin().setEnabled(true);
                    getVtpDelkaHranyMin().setText("");
                    getLblDelkaHranyMax().setEnabled(true);
                    getVtpDelkaHranyMax().setEnabled(true);
                    getVtpDelkaHranyMax().setText("");
                } else {
                    getLblDelkaHranyMin().setEnabled(false);
                    getVtpDelkaHranyMin().setEnabled(false);
                    getVtpDelkaHranyMin().setText("1");
                    getLblDelkaHranyMax().setEnabled(false);
                    getVtpDelkaHranyMax().setEnabled(false);
                    getVtpDelkaHranyMax().setText("1");
                }
            }
        });
        panelOhodnoceniGrafu.add(cbOhodnoceniGrafu, BorderLayout.WEST);

        panelOhodnoceniGrafu.setMaximumSize(new Dimension(Integer.MAX_VALUE, panelOhodnoceniGrafu.getMinimumSize().height));
        add(panelOhodnoceniGrafu);

    }

    public ValidovaneTextovePole getVtpPocetUzlu() {
        return vtpPocetUzlu;
    }

    public ValidovaneTextovePole getVtpPocetHran() {
        return vtpPocetHran;
    }

    public ValidovaneTextovePole getVtpDelkaHranyMin() {
        return vtpDelkaHranyMin;
    }

    public ValidovaneTextovePole getVtpDelkaHranyMax() {
        return vtpDelkaHranyMax;
    }

    public JComboBox getCmbTypGrafu() {
        return cmbTypGrafu;
    }

    public JCheckBox getCbOhodnoceniGrafu() {
        return cbOhodnoceniGrafu;
    }

    public JLabel getLblPocetUzlu() {
        return lblPocetUzlu;
    }

    public JLabel getLblPocetHran() {
        return lblPocetHran;
    }

    public JLabel getLblDelkaHranyMin() {
        return lblDelkaHranyMin;
    }

    public JLabel getLblDelkaHranyMax() {
        return lblDelkaHranyMax;
    }

    public JLabel getLblTypGrafu() {
        return lblTypGrafu;
    }

}
