package model;

import java.io.File;

import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.UIManager;

public class DialogoveOknoProUlozeniSouboru extends JFileChooser {

    String format;

    public DialogoveOknoProUlozeniSouboru(String format) {

        super(System.getProperty("user.dir")); //nastavení výchozího adresáře pro uložení souboru

        this.format = format;

        //nastavení JFileChooseru do češtiny
        UIManager.put("FileChooser.acceptAllFileFilterText", "Všechny soubory");
        UIManager.put("FileChooser.cancelButtonToolTipText", "Zrušit uložení souboru");
        UIManager.put("FileChooser.cancelButtonText", "Zrušit");
        UIManager.put("FileChooser.detailsViewButtonToolTipText", "Podrobnosti");
        UIManager.put("FileChooser.directoryOpenButtonText", "Otevřít");
        UIManager.put("FileChooser.directoryDescriptionText", "Adresář");
        UIManager.put("FileChooser.directoryOpenButtonToolTipText", "Otevřít vybraný soubor");
        UIManager.put("FileChooser.fileAttrHeaderText", "Vlastnosti");
        UIManager.put("FileChooser.fileDateHeaderText", "Datum změny");
        UIManager.put("FileChooser.fileNameHeaderText", "Název");
        UIManager.put("FileChooser.fileNameLabelText", "Název souboru:");
        UIManager.put("FileChooser.fileSizeHeaderText", "Velikost");
        UIManager.put("FileChooser.filesOfTypeLabelText", "Uložit jako typ:");
        UIManager.put("FileChooser.fileTypeHeaderText", "Typ položky");
        UIManager.put("FileChooser.helpButtonText", "Nápověda");
        UIManager.put("FileChooser.helpButtonToolTipText", "Zobrazit nápovědu");
        UIManager.put("FileChooser.homeFolderToolTipText", "Plocha");
        UIManager.put("FileChooser.listViewButtonToolTipText", "Seznam");
        UIManager.put("FileChooser.lookInLabelText", "Přejít do:");
        UIManager.put("FileChooser.newFolderErrorText", "Nepodařilo se vytvořit novou složku");
        UIManager.put("FileChooser.newFolderToolTipText", "Vytvořit novou složku");
        UIManager.put("FileChooser.openButtonText", "Otevřít");
        UIManager.put("FileChooser.openButtonToolTipText", "Otevřít vybraný soubor");
        UIManager.put("FileChooser.openDialogTitleText", "Otevřít");
        UIManager.put("FileChooser.saveButtonText", "Uložit");
        UIManager.put("FileChooser.saveButtonToolTipText", "Uložit vybraný soubor");
        UIManager.put("FileChooser.saveDialogTitleText", "Uložit jako");
        UIManager.put("FileChooser.saveInLabelText", "Uložit do:");
        UIManager.put("FileChooser.updateButtonText", "Obnovit");
        UIManager.put("FileChooser.updateButtonToolTipText", "Obnovit výpis");
        UIManager.put("FileChooser.upFolderToolTipText", "O úroveň výš");
        UIManager.put("FileChooser.newFolderActionLabelText", "Nová složka");
        UIManager.put("FileChooser.refreshActionLabelText", "Obnovit");
        UIManager.put("FileChooser.listViewActionLabelText", "Seznam");
        UIManager.put("FileChooser.detailsViewActionLabelText", "Podrobnosti");
        UIManager.put("FileChooser.viewMenuLabelText", "Zobrazit");

        updateUI();

    }

    @Override
    public void approveSelection() {

        String absolutniCestaUkladanehoSouboruISeSouboremSKoncovkou = getSelectedFile().getAbsolutePath();

        File pomocnyFile = new File(absolutniCestaUkladanehoSouboruISeSouboremSKoncovkou + format);
        if (pomocnyFile.exists() && getDialogType() == SAVE_DIALOG) {
            String nazevSouboru = pomocnyFile.getName();
            Object[] moznostiCesky = {"Ano", "Ne"};
            int result = JOptionPane.showOptionDialog(this, "Soubor " + nazevSouboru + " již existuje.\nChcete ho nahradit?", "Potvrdit uložení jako", JOptionPane.YES_NO_OPTION, JOptionPane.WARNING_MESSAGE, null, moznostiCesky, moznostiCesky[0]);
            switch (result) {
                case JOptionPane.YES_OPTION:
                    super.approveSelection();
                    return;
                case JOptionPane.NO_OPTION:
                    return;
                case JOptionPane.CLOSED_OPTION:
                    return;
            }
        }
        super.approveSelection();
    }

}
